/*******************************************************************************
 * Copyright (c) 2003, 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 * Port to the D programming language:
 *      John Reimer <terminal.node@gmail.com>
 *******************************************************************************/
module dwt.browser.SimpleEnumerator;

//import dwt.dwthelper.utils;

//import dwt.internal.C;
import XPCOM = dwt.internal.mozilla.XPCOM;

import dwt.internal.mozilla.Common;
import dwt.internal.mozilla.nsID;
import dwt.internal.mozilla.nsISimpleEnumerator;
import dwt.internal.mozilla.nsISupports;

class SimpleEnumerator : nsISimpleEnumerator{
//    XPCOMObject supports;
//    XPCOMObject simpleEnumerator;
    int refCount = 0;
    nsISupports[] values;
    int index = 0;

this (nsISupports[] values) {
    this.values = values;
    for (int i = 0; i < values.length; i++) {
        values[i].AddRef ();
    }
    //createCOMInterfaces ();
}

nsrefcnt AddRef () {
    refCount++;
    return refCount;
}

nsresult QueryInterface (nsID* riid, void** ppvObject) {
    if (riid is null || ppvObject is null) return XPCOM.NS_ERROR_NO_INTERFACE;
    //nsID guid = new nsID ();
    //XPCOM.memmove (guid, riid, nsID.sizeof);

    if (*riid == nsISupports.IID) {
        *ppvObject = cast(void*)cast(nsISupports)this;
        AddRef ();
        return XPCOM.NS_OK;
    }
    if (*riid == nsISimpleEnumerator.IID) {
        *ppvObject = cast(void*)cast(nsISimpleEnumerator)this;
        AddRef ();
        return XPCOM.NS_OK;
    }

    *ppvObject = null;
    return XPCOM.NS_ERROR_NO_INTERFACE;
}

nsresult Release () {
    refCount--;
    //if (refCount is 0) disposeCOMInterfaces ();
    return refCount;
}

nsresult HasMoreElements (PRBool* _retval) {
    bool more = values !is null && index < values.length;
    *_retval = more ? 1 : 0; /*PRBool */
    return XPCOM.NS_OK;
}   
    
nsresult GetNext (nsISupports* _retval) {
    if (values is null || index is values.length) return XPCOM.NS_ERROR_UNEXPECTED;
    nsISupports value = values[index++];
    value.AddRef ();
    *_retval = value;
    return XPCOM.NS_OK;
}       
}

